#include <cstdlib>
#include "numbertheory.h"

// Greatest Common Divisor
int gcd(int a, int b) {

  a = abs(a);
  b = abs(b);

  if (a == 0)
    return b;
  if (b == 0)
    return a;

  do {
    int t = a % b;
    a = b;
    b = t;
  } while (b != 0);

  return a;
}

// Least Common Multiple
int lcm(int a, int b) {
  if (a == 0 || b == 0)
    return 0;
  return a*(b/gcd(a,b));
}

// Greatest Common Divisor
long gcd(long int a, long int b) {

  a = abs(a);
  b = abs(b);

  if (a == 0)
    return b;
  if (b == 0)
    return a;

  do {
    long int t = a % b;
    a = b;
    b = t;
  } while (b != 0);

  return a;
}

// Least Common Multiple
long lcm(long int a, long int b) {
  if (a == 0 || b == 0)
    return 0;
  return a*(b/gcd(a,b));
}
