#include <iostream>
#include <iomanip>
#include <cstdlib>
#include "bingo.h"

using namespace std;
using namespace LFRNG;

int main () {
  unsigned seed = 3141592653U;

  cout << "Let's play bingo!" << endl;
  cout << "Enter a seed: ";
  cin >> seed;
  cout << endl;

  srand(seed);
  bingo onPlay;
  
  do {
    unsigned number = onPlay();
    cout << "Extraction is: " << setw(4) << number << endl;
    cout << "Left " << onPlay.left() << ", Drawn (" << onPlay.drawn() << ") = ";
    for (int i=1; i<=onPlay.drawn(); i++) {
      cout << setw(3) << onPlay.drawn(i);
    }
    cout << endl;
  } while (!onPlay.empty());
  
  return 0;
}
