#ifndef NUMBER_THEORY_H
#define NUMBER_THEORY_H

#include <cstdlib>

// Greatest Common Divisor
template <class IT>
IT gcd(IT a, IT b) {

  a = abs(a);
  b = abs(b);

  if (a == 0)
    return b;
  if (b == 0)
    return a;

  do {
    IT t = a % b;
    a = b;
    b = t;
  } while (b != 0);

  return a;
}

#endif
