#ifndef PARFRNG_H
#define PARFRNG_H

#include <limits>
#include <cmath>
#include "lfrng.h"
#include "frng.h"

namespace FPRNG {

class fparrng : public frejrng {
protected:
    virtual bool accept(double u1, double u2, double& r);
public:
    explicit fparrng(unsigned n = 98) : frejrng(n) {}
    fparrng(unsigned n, const unsigned *a): frejrng(n, a) {}
};

} // namespace FPRNG

#endif
