#include <iostream>
#include "polynomial.h"

using namespace std;

int main() {
    double a[] = {1.0, 2.0, 3.0};
    polynomial<2> p(a);

    cout << "Out-of-bound index coefficients: p[4] = " << p[4] << endl;

    cout << "coefficients: " << p[0] << " " << p[1] << " " << p[2] << endl;

    p[1] = -p[1];

    cout << "coefficients: " << p[0] << " " << p[1] << " " << p[2]<<endl;
    
    for(int i=-5; i<6; ++i) {
       double x = i*0.5;
       cout << "p(" << x << ") = " << p(x) << endl;
    }
    
    return 0;
}
